import FreeCAD as App
import FreeCADGui as Gui

from kipy import KiCad

from . import settings
from .bases import BaseObject, BaseViewProvider

class APIObject(BaseObject):
    TYPE = 'KiConnect::API'

    def __init__(self, parent, feature):
        super(APIObject, self).__init__(parent, feature)

        feature.addProperty('App::PropertyFile', 'Socket', 'KiConnect', 'Path to the KiCAD Socket File').Socket = '/tmp/kicad/api.lock'

    def execute(self, feature):
        self.parent.ping_connection()


class APIViewProvider(BaseViewProvider):
    pass


    def __init__(self):
        self.feature = App.ActiveDocument.addObject('App::FeaturePython', 'API')

        APIObject(self, self.feature)
        APIViewProvider(self, self.feature.ViewObject)

        self.kicad = KiCad()
        self.ping_connection()

    @property
    def is_connected(self):
        return self._connected

    def ping_connection(self):
        try:
            self.kicad.ping()
            feature.Connected = True
        except Exception as e:
            print(e)
            feature.Connected = False
    pass


class APIViewProvider(BaseViewProvider):
    ICON = 'icon_footprint_browser.svg'
    TYPE = 'KiConnect::API'

    def __init__(self, parent, viewprovider):
        super(APIViewProvider, self).__init__(parent, viewprovider)


class API():
    def __init__(self):
        self.feature = App.ActiveDocument.addObject('App::FeaturePython', 'API')

        self.object = APIObject(self, self.feature)
        self.viewobject = APIViewProvider(self, self.feature.ViewObject)

